//<c>   Copyright 1990-2000 by Gerry J. Danen; all rights reserved.

/*
        Identify where an area code originates from or
        the area code for a given state.

        Jon Simkins, Softfocus, 1343 Stanbury Dr., Oakville, Ontario
        (416)825-0903
*/
#include"gd_tools.h"


#define pgVERS_ "V2.00"
#define pgTITL_ "Area Code Identification"
#define pgCOPR_ "1990"


#define CODE 0
#define NAME 1


/*      Here's the brains of the program, courtesy Ma Bell's big blue book.
        The tz field is intended for future expansion should I get enthusiastic
        enough to add time zone information.
*/
static  struct
{
    int         code ;          // area code
    char        *state ;        // state/province
    int         tz ;            // hours plus GMT
}
    ac[] =
{
    403, "Alberta", 0,
    780, "Alberta", 0,
    604, "British Columbia", 0,
    204, "Manitoba", 0,
    506, "New Brunswick", 0,
    709, "Newfoundland (Labrador as well)", 0,
    403, "Northwest Territories", 0,
    902, "Nova Scotia", 0,
    519, "Ontario", 0,
    416, "Ontario", 0,
    705, "Ontario", 0,
    613, "Ontario", 0,
    807, "Ontario", 0,
    902, "Prince Edward Island", 0,
    819, "Quebec", 0,
    514, "Quebec", 0,
    418, "Quebec", 0,
    306, "Saskatchewan", 0,
    403, "Yukon", 0,
    205, "Alabama", 0,
    907, "Alaska", 0,
    602, "Arizona", 0,
    501, "Arkansas", 0,
    707, "California", 0,
    916, "California", 0,
    415, "California", 0,
    408, "California", 0,
    209, "California", 0,
    805, "California", 0,
    818, "California", 0,
    213, "California", 0,
    714, "California", 0,
    619, "California", 0,
    303, "Colorado", 0,
    203, "Connecticut", 0,
    302, "Delaware", 0,
    202, "District of Columbia", 0,
    904, "Florida", 0,
    305, "Florida", 0,
    813, "Florida", 0,
    404, "Georgia", 0,
    912, "Savannah", 0,
    808, "Hawaii", 0,
    208, "Idaho", 0,
    312, "Illinois", 0,
    815, "Illinois", 0,
    309, "Illinois", 0,
    217, "Illinois", 0,
    618, "Illinois", 0,
    812, "Indiana", 0,
    219, "Indiana", 0,
    317, "Indiana", 0,
    712, "Iowa", 0,
    515, "Iowa", 0,
    319, "Iowa", 0,
    913, "Kansas", 0,
    316, "Kansas", 0,
    606, "Kentucky", 0,
    502, "Kentucky", 0,
    504, "Louisiana", 0,
    318, "Louisiana", 0,
    207, "Maine", 0,
    301, "Maryland", 0,
    617, "Massachusetts", 0,
    413, "Massachusetts", 0,
    313, "Michigan", 0,
    517, "Michigan", 0,
    616, "Michigan", 0,
    218, "Minnwsota", 0,
    612, "Minnwsota", 0,
    507, "Minnwsota", 0,
    601, "Mississippi", 0,
    816, "Missouri", 0,
    314, "Missouri", 0,
    406, "Montana", 0,
    402, "Nebraska", 0,
    702, "Nevada", 0,
    603, "New Hampshire", 0,
    609, "New Jersey", 0,
    201, "New Jersey", 0,
    505, "New Mexico", 0,
    518, "New York", 0,
    607, "New York", 0,
    716, "New York", 0,
    516, "New York", 0,
    914, "New York", 0,
    704, "North Carolina", 0,
    701, "North Dakota", 0,
    216, "Ohio", 0,
    513, "Ohio", 0,
    614, "Ohio", 0,
    419, "Ohio", 0,
    405, "Oklahoma", 0,
    503, "Oregon", 0,
    814, "Pennsylvania", 0,
    412, "Pennsylvania", 0,
    215, "Pennsylvania", 0,
    814, "Pennsylvania", 0,
    401, "Rhode Island", 0,
    803, "South Carolina", 0,
    605, "South Dakota", 0,
    615, "Tennessee", 0,
    901, "Tennessee", 0,
    806, "Texas", 0,
    512, "Texas", 0,
    214, "Texas", 0,
    915, "Texas", 0,
    817, "Texas", 0,
    713, "Texas", 0,
    409, "Texas", 0,
    801, "Utah", 0,
    802, "Vermont", 0,
    703, "Virginia", 0,
    804, "Virginia", 0,
    206, "Washington", 0,
    509, "Washington", 0,
    304, "West Virginia", 0,
    414, "Wisconsin", 0,
    715, "Wisconsin", 0,
    608, "Wisconsin", 0,
    307, "Wyoming", 0,
    0, "", 0
};


void    main( int argc, char *argv[] )
{
    int which, j, found, code;

    tt_init( SHAREWARE_VERSION, 0, pgVERS_, pgTITL_, pgCOPR_ );
    logon(0);

    //  check paramaters

    if ( argc != 2 )
    {
        printf( "\nUsage:\n\n\t%s <area code>|<state name>\n", get_global_program_name() );
        exit( ERROR );
    }

    which = isdigit(**(++argv)) ? CODE : NAME ;

    if ( which == CODE )
        code = atoi(*argv);

    for ( j=0, found=ERROR ; ac[j].code ; j++ )
    {
        if ( which == CODE )
        {
            if ( code == ac[j].code )
            {
                found = j;
                break;
            }
        }
        else
        {
            if ( StrEq( *argv, ac[j].state ) )
            {
                found = j;
                printf( "%03d - %s\n", ac[j].code, ac[j].state );
            }
        }
    }
    if ( found != ERROR )
    {
        if ( which == CODE )
            printf( "%d - %s\n", ac[j].code, ac[j].state );
    }
    else
        printf( "no match found\n" );
}
